GameplaySettings{
		usepuzzlegrid = false,
		puzzlerows = 1,
		puzzlecols = 1,
        greypercent= .45,
        colorcount=1,
        usetraffic = true,
        automatic_traffic_collisions = false, -- the game shouldn't check for block collisions since we'll be doing that ourselves in this script
        jumpmode="none",
        matchcollectionseconds=0,
        greyaction="normal", -- "eraseall"  -- "eraseblock"
		trafficcompression = trafficCompression,--how fast the blocks appear to move relative to the player's speed

		--track generation settings
		gravity=-.45, -- even without jumping the gravity setting is (a little bit) relevant. It's used in generating the track to sculpt it steep enough to allow jumps
        playerminspeed = 0.2,--so the player is always moving somewhat
        playermaxspeed = 3.9,--2.5
        minimumbestjumptime = 2.5,--massage the track until a jump of at least this duration is possible
        uphilltiltscaler = 1.5,--set to 1 for normal track. higher for steeper
        downhilltiltscaler = 1.5,--set to 1 for normal track. higher for steeper
        uphilltiltsmoother = 0.03,
        downhilltiltsmoother = 0.06,
        useadvancedsteepalgorithm = true,--set false for a less extreme track
        alldownhill = false,
		--end track generation settings
}

SetSkinProperties{
	lanedividers={-1.5,1.5},
	shoulderlines={-4.5,4.5},
	trackwidth = 5,
	prefersteep = false
}

function deepcopy(orig) -- a pretty standard lua function for making a copy of a table
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end

player={
	score=0,
	prevInput={},
	iPrevRing=0,
	hasFinishedScoringPrevRing=false,
	uniqueName = "Player",
	num=1,
	prevFirstBlockCollisionTested = 1,
	pos = {0,0,0},
	posCosmetic = {0,0,1.5},
	controller = "mouse",
	points = 0 -- used for accumulating points this player earns at each match collection. temp var
}


function OnTrackCreated(theTrack)--track is created before the traffic
	track = theTrack --store a global copy of the track to maybe use later
	-- when you return a track table from this function the game will read and apply any changes you made
end

lanespace = 3
half_lanespace = 1.5
totalcolored = 0
hit = 0
stealth = true

blocks = blocks or {}
blockNodes = blockNodes or {}
blockOffsets = blockOffsets or {}
blockColors = blockColors or {}

function OnTrafficCreated(theTraffic)
	half_lanespace = lanespace / 2

	traffic = theTraffic

    for i = 1, #traffic do
    	local lane = traffic[i].lane
    	local strafe = lane*lanespace
    	local offset = {strafe,0,0}
		traffic[i].chainstart = traffic[i].impactnode -- These two lines remove the line leading up to a block, they look ugly if the block is raised.
		traffic[i].chainend = traffic[i].impactnode
		local block = {}
		block.lane = lane
		block.hidden = false
		block.tested = false
		block.type = traffic[i].type
		blocks[#blocks+1]=block
		blockNodes[#blockNodes+1] = traffic[i].impactnode
		blockOffsets[#blockOffsets+1] = offset
		blockColors[#blockColors+1] = track[traffic[i].impactnode].color
    end
	
	for i=1, #blocks do
		if blocks[i].type == 6 then
			totalcolored = totalcolored + 1
		end
	end
    -- return traffic -- when you return a traffic table from this function the game will read and apply any changes you made
end
function InsertCorkscrew(theTrack, startNode, endNode)
	if endNode < #theTrack then
	repeat
	r=math.random(3)-2
	until r~=0
		local rollIncrement = r * 360 / (endNode-startNode)
	    for i = startNode, endNode do
		if i==startNode+(endNode-startNode)/2 and math.random(2)==1 then rollIncrement=rollIncrement*-1 end
	        theTrack[i].roll = theTrack[i-1].roll+rollIncrement
	    	theTrack[i].funkyrot = true
	    end
	    for i = endNode + 1, math.min(#theTrack, endNode+math.random(20)) do
	        theTrack[i].funkyrot = true
	    end
		 for i = endNode + 1, #theTrack do
	        theTrack[i].roll = theTrack[i-1].roll
	    end
	end

    return theTrack
end
function InsertPCorkscrew(theTrack, startNode, endNode)
	if endNode < #theTrack then
	repeat
	r=math.random(3)-2
	until r~=0
		local panIncrement = r * 360 / (endNode-startNode)
	    for i = startNode, endNode do
		if i==startNode+(endNode-startNode)/2  and math.random(2)==1 then panIncrement=panIncrement*-1 end
	        theTrack[i].pan = theTrack[i-1].pan+panIncrement
	    	theTrack[i].funkyrot = true
	    end
	    for i = endNode + 1, math.min(#theTrack, endNode+math.random(20)) do
	        theTrack[i].funkyrot = true
	    end
		 for i = endNode + 1, #theTrack do
	        theTrack[i].pan = theTrack[i-1].pan
	    end
	end

    return theTrack
end
function InsertSlalom(theTrack, startNode, speed, rr, maxroll, left)
	--startNode = math.floor(startNode)
	repeat
	r=math.random(3)-2
	until r~=0
	speed = speed*r
	
	   for i = startNode+1, startNode+maxroll do
	   theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan-speed
			if (i<=startNode+math.floor(maxroll/2)) then
			theTrack[i].roll = theTrack[i-1].roll+speed*2
			else
			theTrack[i].roll = theTrack[i-1].roll-speed*2
			end
	    end
		startNode=startNode+maxroll
		for i = startNode+1, startNode+maxroll+left do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan+speed
			theTrack[i].roll = theTrack[i-1].roll-speed*2
			--theTrack[i].tilt = theTrack[i-1].tilt-1
	    end
		startNode=startNode+maxroll+left
		for i = startNode+1, startNode+maxroll+left do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan+speed
			if rr==8 then
			theTrack[i].roll = theTrack[i-1].roll+speed
			else
			theTrack[i].roll = theTrack[i-1].roll+speed*2
			end
			--theTrack[i].tilt = theTrack[i-1].tilt+1
	    end
		startNode=startNode+maxroll+left
		if rr==8 then
		for i = startNode+1, startNode+maxroll do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan
			theTrack[i].roll = theTrack[i-1].roll+speed
			--theTrack[i].tilt = theTrack[i-1].tilt+1
	    end
		startNode=startNode+maxroll
		for i = startNode+1, startNode+maxroll do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan
			theTrack[i].roll = theTrack[i-1].roll+speed
			--theTrack[i].tilt = theTrack[i-1].tilt-1
	    end
		startNode=startNode+maxroll
		for i = startNode+1, startNode+maxroll+left do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan-speed
			theTrack[i].roll = theTrack[i-1].roll+speed
			--theTrack[i].tilt = theTrack[i-1].tilt-1
	    end
		startNode=startNode+maxroll+left
		for i = startNode+1, startNode+maxroll+left do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan-speed
			theTrack[i].roll = theTrack[i-1].roll-speed*2
			--theTrack[i].tilt = theTrack[i-1].tilt+1
		end
		startNode=startNode+maxroll+left
		for i = startNode+1, startNode+maxroll do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan+speed
			if (i<=startNode+math.floor(maxroll/2)) then
			theTrack[i].roll = theTrack[i-1].roll-speed*2
			else
			theTrack[i].roll = theTrack[i-1].roll+speed*2
			end
	    end
		else 
		for i = startNode+1, startNode+maxroll do
		theTrack[i].funkyrot = true
	        theTrack[i].pan = theTrack[i-1].pan-speed
			if (i<=startNode+math.floor(maxroll/2)) then
			theTrack[i].roll = theTrack[i-1].roll+speed*2
			else
			theTrack[i].roll = theTrack[i-1].roll-speed*2
			end
	    end
		end
		startNode=startNode+maxroll
		for i = startNode+1, math.min(#theTrack, startNode+math.random(20)) do
	        theTrack[i].funkyrot = true
	    end
    return theTrack
end

function InsertLoopyLoop(theTrack, apexNode, circumference)
	circumference = math.floor(circumference)
	apexNode = math.floor(apexNode)
    local halfSize = math.floor(circumference / 2)

    if (apexNode < halfSize) or ((apexNode + halfSize) > #theTrack) then
    	return theTrack
    end
	repeat
	r=math.random(3)-2
	until r~=0
    local startRing = math.max(1,apexNode - halfSize)
    local endRing = math.min(#theTrack, apexNode + halfSize)
    local span = endRing - startRing
    local startTilt = theTrack[startRing].tilt
    local endOriginalTilt = theTrack[endRing].tilt
    local endOriginalPan = theTrack[endRing].pan
    local tiltDeltaOverEntireLoop = -360 + (endOriginalTilt - startTilt)
    local startPan = theTrack[startRing].pan
    local pan = startPan

	local panConstant = r*60*(math.random()+1) -- make this number bigger if you have problems with loops running into themselves
    local panRate = panConstant / halfSize

    local panRejoinSpan = math.max(circumference*2, 200)
    local panRejoinNode = math.min(#theTrack, endRing + panRejoinSpan)

    if theTrack[panRejoinNode].pan > startPan then
    	panRate = -panRate -- the loop should bend towards the future track segments naturally
    end

    local midRing = startRing + halfSize + math.ceil(halfSize/10)

    for i = startRing+1, endRing do
        theTrack[i].tilt = startTilt + tiltDeltaOverEntireLoop * ((i - startRing) / span)

        if i==midRing then panRate = -panRate end

        pan = pan + panRate -- pan just a little while looping to make sure it doesn't run into itself
        theTrack[i].pan = pan
    end

    local panDeltaCascade = theTrack[endRing].pan - endOriginalPan
    local tiltDeltaCascade = theTrack[endRing].tilt - endOriginalTilt;
    for i = endRing + 1, #theTrack do
        theTrack[i].tilt = theTrack[i].tilt + tiltDeltaCascade
        theTrack[i].pan = theTrack[i].pan + panDeltaCascade
    end
	for i = endRing + 1, math.min(endRing+math.random(20),#theTrack) do
	        theTrack[i].funkyrot = true
	    end
    return theTrack
end
function InsertLoop(theTrack, startNode, endNode)
	    for i = startNode, math.min(#theTrack, endNode+math.random(20)) do
	        theTrack[i].funkyrot = true
	    end
    return theTrack
end
loops={}
function OnRequestTrackReshaping(theTrack)
track = theTrack
		--track[1].tilt = 30
		track[1].pan = 0
		track[1].funkyrot=true
		i=2
		while i<=10 do
		--track[i].tilt = 30
		track[i].pan = 0
		track[i].funkyrot=true
		i=i+1
		end
		while i<=#track do
		--track[i].tilt = 30
		track[i].pan = 0
		track[i].funkyrot=false
		i=i+1
		end
		last=0
	for i=10,#track do
	if (track[i].funkyrot==false) then
	r1=math.max(.7,1-track[i].tilt/100)
	r1=math.min(r1,1.7)
	RAND=math.random(4)
	r111=math.floor(r1*100)+50
	if RAND==2 then
	if 	r1>.9 and r1<1.5 then
	track[i].funkyrot=true
	elseif track[i].tilt*track[math.min(#theTrack, i+r111)].tilt>0 then
	track=InsertPCorkscrew(track,i,i+r111)
	else track[i].funkyrot=true
	end
	elseif RAND==1 and r1<.9 then
	track=InsertCorkscrew(track,i,i+r111)
	elseif RAND==3 then
	loops[#loops+1]={x=(i+i+r111)/2,y=r111}
	track=InsertLoop(track,i,i+r111)
	else
	rr=math.random(2)*4
		maxroll = math.floor(45/r1)
		left = math.ceil(45-maxroll*r1)
	if (i+maxroll*rr+left*rr/2 < #theTrack) then track = InsertSlalom(track, i, r1,rr,maxroll,left) 
	end
	
	end
	end
	end
	if #loops>0 then
	for i=1,#loops do
	track=InsertLoopyLoop(track,loops[i].x,loops[i].y)
	end
	end
	return track
end
function OnSkinLoaded()-- called after OnTrafficCreated. The skin script has loaded content.
	SetScoreboardNote{text="/"..totalcolored.." | STEALTH"}
	SetGlobalScore{score=0,showdelta=false}
end

score = 0

iCurrentRing = 0 --Update function keeps this current
blocksToHide = {}

function Collide(strafe)
	local playerLane = 0;
	if strafe>half_lanespace then playerLane = 1
	elseif strafe<-half_lanespace then playerLane=-1 end

	local maxRing = iCurrentRing + 2
	local foundFirst = false
	for i=player.prevFirstBlockCollisionTested,#blockNodes do
		if not blocks[i].tested then
			if blockNodes[i] <= maxRing then
				if not foundFirst then
					player.prevFirstBlockCollisionTested = i
					foundFirst = true
				end

				if blockNodes[i] <= math.floor(iCurrentRing) then
					if not blocks[i].hidden then
						if (blocks[i].lane == playerLane) or hitAllLanes then
							blocksToHide[#blocksToHide+1] = i
							blocks[i].hidden = true
							local blockOffset = blockOffsets[i]
							if blocks[i].type == 5 then
								PlaySound{name="landcrash"}
								score = score - 1
								stealth = false
								SetScoreboardNote{text="/"..totalcolored}
							else
								score = score + 1
								hit = hit + 1
							end
							SendCommand{command="HoverUp"} -- causes the hovering vehicle to bounce up a bit
							SetGlobalScore{score=score,showdelta=true}
						end
					end
					blocks[i].tested = true
				end
			else
				break --stop the loop once we get to a block way past the player
			end
			--end
		end
	end
	
	--if #blocksToHide > 0 then UpdateBatchRenderer{uniqueName="BlockBatchRenderer", hideLocations=blocksToHide} end
end


function Update(dt, tracklocation, playerstrafe, input) --called every frame
	iCurrentRing = math.floor(tracklocation)
	local playersInput = input["players"]
	local mouseInput = input["mouse"]

	blocksToHide = {}
	Collide(playerstrafe)

	if #blocksToHide > 0 then
		local pitch = 1
		PlaySound{name="hit",pitch=pitch} -- PlaySound{name="hit",pitch=pitch,volume=1,loopseconds=0}
		HideTraffic(blocksToHide)
	end
end

function OnRequestFinalScoring()
	local allhitbonus = 0
	local stealthbonus = 0
	local perfectbonus = 1
	local bonuses={}
	table.insert(bonuses,"Notes Hit: "..hit.."/"..totalcolored)
	if hit == totalcolored then
		allhitbonus = math.ceil(hit/50)*10
		table.insert(bonuses,"Hit All Notes: +"..allhitbonus)
	end
	if stealth == true then
		stealthbonus = math.ceil(hit/50)*10
		table.insert(bonuses,"Stealth bonus: +"..stealthbonus)
	end
	if stealth == true and hit == totalcolored then
		perfectbonus = 2
		table.insert(bonuses,"Perfect: x2")
	end
	
	return {
		rawscore = score,
		bonuses = bonuses,
		finalscore = (score + allhitbonus + stealthbonus)*perfectbonus
	}
end